context("Generic tests")
test_that("Sanity checks", {
  #source("csindicators/R/TotalSpellTimeExceedingThreshold.R")
  expect_error(TotalSpellTimeExceedingThreshold(NULL), 
    "Parameter 'data' cannot be NULL.")
  expect_error(TotalSpellTimeExceedingThreshold('x'),
   "Parameter 'data' must be numeric.")
  data <- 1:20
  expect_error(TotalSpellTimeExceedingThreshold(data, NULL),
    "Parameter 'threshold' cannot be NULL.")
  expect_error(TotalSpellTimeExceedingThreshold(data, 'x'),
    "Parameter 'threshold' must be numeric.")
  threshold <- 10
  expect_error(TotalSpellTimeExceedingThreshold(data, threshold),
    paste("argument", '"spell"', "is missing, with no default"))
  dim(data) <- c(2, 10)
  expect_error(TotalSpellTimeExceedingThreshold(data, threshold, spell = 2),
    "Parameter 'data' must have named dimensions.")
  names(dim(data)) <- c('time', 'lat')
  threshold <- array(1:2, 2)
  dim(threshold) <- c(time = 2)
  expect_equal(TotalSpellTimeExceedingThreshold(data, threshold, spell = 2),  
    array(c(0,rep(2,9)), c(lat = 10)))
  data <- array(1:40, c(x = 2, ftime = 20))
  expect_error(TotalSpellTimeExceedingThreshold(data, threshold, spell = 2),
    "Could not find dimension 'time' in 1th object provided in 'data'.")    
  threshold <- 10
  expect_equal(TotalSpellTimeExceedingThreshold(data, threshold, spell = 2, time_dim = 'ftime'), 
               array(c(15, 15), c(x = 2)))
  dim(threshold) <- c(member = 1, ftime = 1)
  expect_equal(TotalSpellTimeExceedingThreshold(data, threshold, spell = 2, time_dim = 'ftime'), 
               array(c(15, 15), c(x = 2, member = 1, ftime = 1)))
  expect_error(TotalSpellTimeExceedingThreshold(data, threshold, spell = 2, time_dim = 'x'),
     paste("Could not find dimension 'x' in 1th object provided in 'data'"))

})
